/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar los registros del archivo de facturas

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             Autor                       Descripcion
    1.0    09-Agosto-2020    Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_ConsiltaDatosClienteVIN_tgr_handler extends TriggerHandler {

	private List<TAM_ConsiltaDatosClienteVIN__c> CteServList;
	private Map<Id,TAM_ConsiltaDatosClienteVIN__c> mapCtesServ;
	
    public TAM_ConsiltaDatosClienteVIN_tgr_handler() {
		this.CteServList = Trigger.new;
		this.mapCtesServ = (Map<Id,TAM_ConsiltaDatosClienteVIN__c>)Trigger.newMap;
	}

	public override void beforeInsert(){
		actalizaRegistros(CteServList);
	}

	public void actalizaRegistros(List<TAM_ConsiltaDatosClienteVIN__c> CteServList){
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros...');

	    String VaRtAccRegPM = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral').getRecordTypeId();
    	String VaRtAccRegPF = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica').getRecordTypeId();
		
		Set<String> setVines = new Set<String>();
		Map<String, Opportunity> mapVinNomCte = new Map<String, Opportunity>();
		Map<String, String> mapVinNomCont = new Map<String, String>();
		Map<String, Opportunity> mapIdVinOppUps = new Map<String, Opportunity>();
		Map<String, Date> mapVinFechaCloseOpp = new Map<String, Date>();
		Map<String, String> mapIdVinIdExt = new Map<String, String>();
		Map<String, TAM_HistoricoClientes__c> mapIdVintObtHistCtes = new Map<String, TAM_HistoricoClientes__c>();
		Map<String, String> mapIdExtIdCte = new Map<String, String>();
        Map<String, String> mapIdExtIdCteSOpp = new Map<String, String>();
		Map<String, Opportunity> mapVinObjOppUps = new Map<String, Opportunity>();
		Map<String, Opportunity> mapIdVinIdOpp = new Map<String, Opportunity>();
		List<AccountShare> lAccountShare = new List<AccountShare>();		
		Map<String, Account> mapIdExtNomObjCte = new Map<String, Account>();
		Set<String> setIdCtesNuvos = new Set<String>();
		Map<String, Vehiculo__c> mapVinObjVeh = new Map<String, Vehiculo__c>();
		Map<String, TAM_ClienteVehiculo__c> mapIdExtObjCteVehUps = new Map<String, TAM_ClienteVehiculo__c>();
        Map<String, TAM_ClienteVehiculo__c> mapIdExtObjCteVehUpsFinal = new Map<String, TAM_ClienteVehiculo__c>();

		Set<String> setIdCteVehicNvo = new Set<String>();
		Set<String> setIdOwnerOpp = new Set<String>();
		Map<String, String> mapIdUsrNomDis = new Map<String, String>();
		List<TAM_ClienteVehiculo__Share>  lClienteVehiculoShare = new List<TAM_ClienteVehiculo__Share>();
        Set<String> setVinNoExist = new Set<String>();
        Set<String> setVinSinCte = new Set<String>();
        Map<String, Factura__c> mapVinObjFactCons = new Map<String, Factura__c>();
        Map<String, TAM_OportunidadFactura__c> mapVinObjOppFactCons = new Map<String, TAM_OportunidadFactura__c>();
        Map<String, TAM_OportunidadFactura__c> mapVinObjOppFactIns = new Map<String, TAM_OportunidadFactura__c>();

        Map<String, TAM_VentasCRM__c> mapVinObjVentasCRM = new Map<String, TAM_VentasCRM__c>();
        Map<String, TAM_VehiculoPaso__c> mapVinObjVehiculoPaso = new Map<String, TAM_VehiculoPaso__c>();
        Map<String, String> mapIdExtNomIdCte = new Map<String, String>();       

        Map<String, String> mapNoDistObj = new Map<String, String>();   
        //Consulta los datos de los distribuidores
        for (Account dist : [SELECT Id, Name, Codigo_Distribuidor__c 
            FROM Account WHERE Codigo_Distribuidor__c != null
            ORDER BY Name ASC ]){
            //Metelo al mapa de mapNoDistObj
            mapNoDistObj.put(dist.Codigo_Distribuidor__c, dist.Name.toUpperCase());
        }
        System.debug('EN actalizaRegistros mapNoDistObj '+ mapNoDistObj.keySet());
        System.debug('EN actalizaRegistros mapNoDistObj '+ mapNoDistObj.Values());
        
		Map<String, String> mapIdGrupoNombre = new Map<String, String>();		
    	for (Group grupoPublico : [Select g.Name, g.Id From Group g
				where (Name LIKE : '%TOYOTA%' OR Name LIKE : '%TMEX%')]){
    		mapIdGrupoNombre.put(grupoPublico.Name.toUpperCase(), grupoPublico.id);
    	}		
		System.debug('EN actalizaRegistros mapIdGrupoNombre: ' + mapIdGrupoNombre.keySet() + ' ' + mapIdGrupoNombre.values());
		
		//Recorre la lista de CteServList y toma el vin que viene en el campo de Name
		for (TAM_ConsiltaDatosClienteVIN__c objVinPaso : CteServList){
			setVines.add(objVinPaso.Name);
			mapVinFechaCloseOpp.put(objVinPaso.Name, objVinPaso.TAM_FechaCierre__c);				
		}
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros setVines: ' + setVines);
		
		for (Opportunity opp : [Select o.TAM_Vin__c, o.Id, o.AccountId,o.Account.Name, Account.TAM_IdExternoNombre__c,
		    o.TAM_Distribuidor__r.Name, o.TAM_Distribuidor__c, OwnerId, o.TAM_IdExterno__c 
		    From Opportunity o Where TAM_Vin__c IN :setVines ]){
			mapIdVinIdOpp.put(opp.TAM_Vin__c, opp);
			setIdOwnerOpp.add(opp.OwnerId);
		}
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdVinIdOpp: ' + mapIdVinIdOpp);		
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros setIdOwnerOpp: ' + setIdOwnerOpp);		

        //Ve si ya existe una factura asociada a esta venta y crea el objeto del tipo TAM_OportunidadFactura__c
        for (Factura__c objFactura : [Select f.TAM_VinForm__c, f.TAM_Numero__c, f.Name, f.Id 
            From Factura__c f Where TAM_VinForm__c IN :setVines]){
            //Metelo al mapa de mapVinObjFactCons
            mapVinObjFactCons.put(objFactura.TAM_VinForm__c, objFactura);
        }
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjFactCons: ' + mapVinObjFactCons);       
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjFactCons: ' + mapVinObjFactCons);       

        //Ve si ya existe una factura asociada a esta venta y crea el objeto del tipo TAM_OportunidadFactura__c
        for (TAM_OportunidadFactura__c objOppFactura : [Select f.Id, f.TAM_Oportunidad__r.TAM_Vin__c, 
            f.TAM_Factura__c From TAM_OportunidadFactura__c f 
            Where TAM_Oportunidad__r.TAM_Vin__c IN :setVines]){
            //Metelo al mapa de mapVinObjFactCons
            mapVinObjOppFactCons.put(objOppFactura.TAM_Oportunidad__r.TAM_Vin__c, objOppFactura);
        }
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjOppFactCons: ' + mapVinObjOppFactCons);       
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjOppFactCons: ' + mapVinObjOppFactCons);

        //Consulta los reg asiados a setIdOwner
        for (User usuario : [Select u.id, u.Distribuidor__c, u.CodigoDistribuidor__c From User u
			where ID IN :setIdOwnerOpp]){
			String sNoDist = Test.isRunningTest() ? 'TMEX' : (usuario.Distribuidor__c != NULL ? usuario.Distribuidor__c : 'TMEX');
       		mapIdUsrNomDis.put(usuario.id, sNoDist);
        }
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdUsrNomDis: ' + mapIdUsrNomDis);		

		//Consulta los datos del Vehiculo
		for (Vehiculo__c objVehi : [Select id, Name, CodigoDistribuidor__c, Distribuidor__r.Name, 
		      AnioModel__c, SerieAD__c, TAM_Version__c, 
		      ColorInternoVehiculo__c, ColorExternoVehiculo__c,
		      ColorInternoVehiculo__r.CodigoColor__c, ColorInternoVehiculo__r.Name,
		      ColorExternoVehiculo__r.CodigoColor__c, ColorExternoVehiculo__r.Name,
		      //Datos del ultimo mov
		      Ultimo_Movimiento__r.TAM_FechaEnvForm__c, Ultimo_Movimiento__r.First_Name__c,
		      Ultimo_Movimiento__r.Last_Name__c, Ultimo_Movimiento__r.Address_2__c,
		      Ultimo_Movimiento__r.City__c, Ultimo_Movimiento__r.State__c, Ultimo_Movimiento__r.Zip__c,
		      Ultimo_Movimiento__r.Tel_Home__c, Ultimo_Movimiento__r.Tel_Work__c,
		      Ultimo_Movimiento__r.E_Mail_2__c, Ultimo_Movimiento__c, 
		      Ultimo_Movimiento__r.TAM_NombrecCompletoFrm__c,
              Ultimo_Movimiento__r.Sale_Code__c, Ultimo_Movimiento__r.Sale_Date__c, 
              Ultimo_Movimiento__r.Submitted_Date__c, Ultimo_Movimiento__r.Submitted_Time__c,
              Ultimo_Movimiento__r.Trans_Type__c, Ultimo_Movimiento__r.TAM_codigoModelo__c,
              Ultimo_Movimiento__r.Year_Modelo__c, Ultimo_Movimiento__r.Year__c,
              Ultimo_Movimiento__r.Month__c
		      From Vehiculo__c Where Name IN: setVines ]){
		    //Agrega los datos del VIN al mapa de mapVinObjVeh
			mapVinObjVeh.put(objVehi.Name, objVehi);
			String sNombCompForm = objVehi.Ultimo_Movimiento__r.TAM_NombrecCompletoFrm__c != null ? objVehi.Ultimo_Movimiento__r.TAM_NombrecCompletoFrm__c.replaceAll('  ', ' ') : 'SIN PROPIETARIO EN MOV';
            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros sNombCompForm: ' + sNombCompForm);			
			//Agrega al mapa de mapIdExtNomIdCte 
			if (objVehi.Ultimo_Movimiento__c != null)
			     mapIdExtNomIdCte.put(objVehi.Name, sNombCompForm);
		}
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjVeh: ' + mapVinObjVeh.KeySet());		
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjVeh: ' + mapVinObjVeh.Values());		
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtNomIdCte: ' + mapIdExtNomIdCte);        

		//Consulta los datos del Histo Ctes
		for (TAM_HistoricoClientes__c objHistCtes : [Select t.oVin__c, t.dTPOBLA__c, t.dTIPVIA__c, t.dSEXO__c, t.dRPOBLA__c, t.dNUMTEL2__c, 
			t.dNUMTEL1__c, t.dNUMINT__c, t.dNUMEXT__c, t.dNOMVIA__c, t.dNEXOS2__c, t.dNEXOS1__c, t.dLPOBLA__c, t.dLMUNIC__c, 
			t.dLENTID__c, t.dDIR_EMA__c, t.dCPOSTA__c, t.dCOORGY__c, t.dCOORGX__c, t.dAPELL2__c, t.dAPELL1__c, t.Name 
			From TAM_HistoricoClientes__c t Where oVin__c IN :setVines  
			Order by oVin__c]){
			//Quita los espacios en blanco que tiene el nombre
			String sNombrePaso = objHistCtes.Name != null ? ' ' + objHistCtes.Name.replaceALL('  ', ' ') : '';
			String sIdExtNombre = sNombrePaso.trim() + '' + (objHistCtes.dNEXOS1__c != null ? ' ' + objHistCtes.dNEXOS1__c : '') + '' + (objHistCtes.dAPELL1__c != null ? ' ' + objHistCtes.dAPELL1__c : '') + '' + (objHistCtes.dNEXOS2__c != null ? ' ' + objHistCtes.dNEXOS2__c : '') + '' + (objHistCtes.dAPELL2__c != null ? ' ' + objHistCtes.dAPELL2__c : '');
			System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros sIdExtNombre: ' + sIdExtNombre);
			
			//Mete al mapa el objeto de objHistCtes
			if (!mapIdVinIdExt.containsKey(objHistCtes.oVin__c))
				mapIdVinIdExt.put(objHistCtes.oVin__c, sIdExtNombre);
			//Mete al mapa el objeto de objHistCtes
			if (!mapIdVintObtHistCtes.containsKey(objHistCtes.oVin__c))
				mapIdVintObtHistCtes.put(objHistCtes.oVin__c, objHistCtes);
			System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros objHistCtes: ' + objHistCtes);
		}		
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdVinIdExt: ' + mapIdVinIdExt);
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdVintObtHistCtes: ' + mapIdVintObtHistCtes);
		
		//Ya rienes los vines busca los clientes que estan asociados a mapIdVinIdExt.values
		for (Account cte : [Select id, TAM_IdExternoNombre__c From Account Where TAM_IdExternoNombre__c IN :mapIdVinIdExt.values() ]){
		      //Agrega el reg al mapa de mapIdExtIdCte 
		      mapIdExtIdCte.put(cte.TAM_IdExternoNombre__c, cte.id);
		}
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtIdCte: ' + mapIdExtIdCte.keyset());
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtIdCte: ' + mapIdExtIdCte.values());

        //Ya rienes los vines busca los clientes que estan asociados a mapIdVinIdExt.values
        if (!mapIdExtNomIdCte.isEmpty()){
	        for (Account cte : [Select id, TAM_IdExternoNombre__c From Account Where TAM_IdExternoNombre__c IN :mapIdExtNomIdCte.values()]){
                //Agrega el reg al mapa de mapIdExtIdCte 
	            mapIdExtIdCteSOpp.put(cte.TAM_IdExternoNombre__c, cte.id);
	        }
        }//Fin si !mapIdExtNomIdCte.siEmpty()
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtIdCteSOpp: ' + mapIdExtIdCteSOpp.keyset());
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtIdCteSOpp: ' + mapIdExtIdCteSOpp.values());

		//Actualiza las opp con los datos de los clientes 
		for (String sVin : setVines){
		    
		    Boolean blnNoExisteCte = false;
			String sIdExtNom = mapIdVinIdExt.get(sVin);
			System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros sIdExtNom: ' + sIdExtNom);
			String SnomDist = '';
			//Tiene Cliente asociado
			if (mapIdExtIdCte.containsKey(sIdExtNom)){
				SnomDist = mapIdVinIdOpp.get(sVin).TAM_Distribuidor__r.Name;
				System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros SnomDist: ' + SnomDist);
				String sIsExtCteVehi = mapIdExtIdCte.get(sIdExtNom);
				System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros sIsExtCteVehi: ' + sIsExtCteVehi);
				if (mapVinObjVeh.containsKey(sVin))
					sIsExtCteVehi += '-' + mapVinObjVeh.get(sVin).id;
				//Ya existe el clienrte entonces crea el objeto del TAM_ClienteVehiculo__c
				mapIdExtObjCteVehUps.put(sIsExtCteVehi, new TAM_ClienteVehiculo__c(
						TAM_IdExterno__c = sIsExtCteVehi, 
						TAM_Cliente__c = mapIdExtIdCte.get(sIdExtNom),
        				TAM_VehIculo__c = mapVinObjVeh.containsKey(sVin) ? mapVinObjVeh.get(sVin).id : null, //mapVinObjVeh.get(sVin).id,
        				OwnerId = mapIdVinIdOpp.get(sVin).OwnerId
					)
				);
			}//Fin si mapIdExtIdCte.containsKey(sIdExtNom)
			
			//No esta en mapIdExtIdCte
            if (!mapIdExtIdCte.containsKey(sIdExtNom) || Test.isRunningTest() ){
                System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdExtIdCte sIdExtNom: ' + sIdExtNom);
                
                //Ve si esta en opportunidad
				if ( (mapIdVinIdOpp.containsKey(sVin) && mapVinObjVeh.containsKey(sVin)) || Test.isRunningTest() ){
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros ESTA EN mapIdVinIdOpp sVin: ' + sVin);
	                String sNombreCtePaso; //mapIdVinIdOpp.get(sVin).Account.TAM_IdExternoNombre__c != null ? mapIdVinIdOpp.get(sVin).Account.TAM_IdExternoNombre__c : (mapIdExtNomIdCte.get(sVin).Account.Name );
                    if (mapIdVinIdOpp.get(sVin).Account.TAM_IdExternoNombre__c != null)
                        sNombreCtePaso = mapIdVinIdOpp.get(sVin).Account.TAM_IdExternoNombre__c;
                    if (sNombreCtePaso == null && mapIdExtNomIdCte.containsKey(sVin))
                        sNombreCtePaso = mapIdExtNomIdCte.get(sVin);                    
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros ESTA EN mapIdVinIdOpp sNombreCtePaso: ' + sNombreCtePaso);
                    String sNombCte = sNombreCtePaso != null ? (sNombreCtePaso.length() > 59 ? sNombreCtePaso.substring(0,59) + ' - ' + sVin : sNombreCtePaso + ' - ' + sVin) : ''; 
                    //String sNombCte = mapIdVinIdOpp.get(sVin).Account.TAM_IdExternoNombre__c != null ? mapIdVinIdOpp.get(sVin).Account.TAM_IdExternoNombre__c.substring(0,59) + ' - ' + sVin : mapIdVinIdOpp.get(sVin).Account.Name.substring(0,59) + ' - ' + sVin; 

                    String sIdOwner = mapIdVinIdOpp.get(sVin).OwnerId;                  
                    String sIdVehi = Test.isRunningTest() ? null : mapVinObjVeh.get(sVin).id;                    
                    //String sIdCte = mapIdVinIdOpp.get(sVin).AccountId != null ? mapIdVinIdOpp.get(sVin).AccountId : (mapIdExtIdCteSOpp.containsKey(sNombreCtePaso) ? mapIdExtIdCteSOpp.get(sNombreCtePaso) : null);

                    String sIdCte;
                    if (mapIdVinIdOpp.get(sVin).AccountId != null)
                        sIdCte = mapIdVinIdOpp.get(sVin).AccountId;
                    if (sIdCte == null && mapIdExtIdCteSOpp.containsKey(sNombreCtePaso))    
                        sIdCte = mapIdExtIdCteSOpp.get(sNombreCtePaso);
                    String sIsExtCteVehi = sIdCte + '-' + sIdVehi;
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros ESTA EN mapIdVinIdOpp sIdCte: ' + sIdCte + ' sIsExtCteVehi: ' + sIsExtCteVehi);
	                
	                //Ya existe el clienrte entonces crea el objeto del TAM_ClienteVehiculo__c
                    TAM_ClienteVehiculo__c objCteVehic = new TAM_ClienteVehiculo__c(
                            Name = sNombCte,
                            TAM_IdExterno__c = sIsExtCteVehi, 
                            TAM_Cliente__c = sIdCte,
                            TAM_VehIculo__c = sIdVehi,
                            OwnerId = sIdOwner
				    );
				    //Metelo al mapa de mapIdExtObjCteVehUps
				    if (sNombreCtePaso != null)
	                   mapIdExtObjCteVehUps.put(sIsExtCteVehi, objCteVehic);
                    if (sIdCte == null){
                       blnNoExisteCte = true;
                       setVinNoExist.add(sVin);                    
                    }
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros ESTA EN mapIdVinIdOpp blnNoExisteCte: ' + blnNoExisteCte);
	                
                    //Crea el objeto del tipo TAM_OportunidadFactura__c
                    TAM_OportunidadFactura__c objTAMOportunidadFacturaPaso = new TAM_OportunidadFactura__c();
                    objTAMOportunidadFacturaPaso.Name = sVin + ' - ' + (mapVinObjFactCons.containsKey(sVin) ? mapVinObjFactCons.get(sVin).TAM_Numero__c : null);
                    objTAMOportunidadFacturaPaso.TAM_Factura__c = mapVinObjFactCons.containsKey(sVin) ? mapVinObjFactCons.get(sVin).id : null;
                    objTAMOportunidadFacturaPaso.TAM_Oportunidad__c = mapIdVinIdOpp.containsKey(sVin) ? mapIdVinIdOpp.get(sVin).id : null;
                    String sIdExterno = (mapVinNomCte.containsKey(sVin) ? mapVinNomCte.get(sVin).id : null) + '-' + (mapVinObjFactCons.containsKey(sVin) ? mapVinObjFactCons.get(sVin).id : null);
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros ESTA EN mapIdVinIdOpp sIdExterno: ' + sIdExterno);
                    
                    //Metelo a la lista de mapVinObjOppFactIns
                    if (!mapVinObjOppFactCons.containsKey(sVin) && objTAMOportunidadFacturaPaso.TAM_Factura__c != null){
                        //Metelo al mapa de mapVinObjOppFactIns 
                        mapVinObjOppFactIns.put(sIdExterno, objTAMOportunidadFacturaPaso);
	                    //Ya tienes la info para crear los clientes 
	                    List<TAM_OportunidadFactura__c> lOppFactUps = mapVinObjOppFactIns.values();
	                    //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
	                    List<Database.Upsertresult> lDtbUpsRes3 = Database.upsert(lOppFactUps, TAM_OportunidadFactura__c.id, false);
	                    //Ve si hubo error
	                    for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes3){
	                        if (!objDtbUpsRes.isSuccess())
	                            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Hubo un error a la hora de crear/Actualizar los registros en TAM_OportunidadFactura__c0 ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
	                        if (objDtbUpsRes.isSuccess())
	                            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Los datos del Cte Vehic se crear/Actualizar con exito TAM_OportunidadFactura__c0 objDtbUpsRes.getId(): ' + objDtbUpsRes.getId());
	                    }//Fin del for para lDtbUpsRes
                    }//Fin si !mapVinObjOppFactCons.containsKey(sVin)
                    
                    //Ve si el objeto de opp tiene asociada la cuenta
                    if (mapIdVinIdOpp.get(sVin).AccountId == null && !blnNoExisteCte){
                        String sIdExternoOpp = sVin + '-' + sIdCte;
                        mapVinObjOppUps.put(sVin, new Opportunity(
                                id = mapIdVinIdOpp.get(sVin).id, TAM_IdExterno__c = sIdExternoOpp, AccountId = sIdCte
                            )   
                        );
                        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros ESTA EN mapIdVinIdOpp mapVinObjOppUps: ' + mapVinObjOppUps);
                        //actualiza el reg de la opp
                        //LOS QUITAS DESPYES DE ACT TODOS LOS REG
                        if (!Test.isRunningTest())
                            update mapVinObjOppUps.values();
                    }//Fin si mapIdVinIdOpp.get(sVin).AccountId == null
                    
                    Integer intCntTotOpp = 0;
                    Opportunity oppDel;
                    //Consulta la opp rel a la vin de sVin                
                    for (Opportunity opp : [Select o.TAM_Vin__c, o.Id, o.AccountId From Opportunity o Where TAM_Vin__c =: sVin ]){
                        String sIdCte1 = opp.AccountId;
                        if (sIdCte1 == null)
                            oppDel = new Opportunity(id = opp.id);                            
                        //Suma uno al contador
                        intCntTotOpp++;
                    }
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros intCntTotOpp: ' + intCntTotOpp + ' oppDel: ' + oppDel);
                    //Esta duplicado el registro del vin en la opp
                    if (intCntTotOpp > 1)
                        if (oppDel != null)
                            if (oppDel.id != null)
                                if (!Test.isRunningTest())
                                    delete oppDel;                    
                    
                    //LOS QUITAS DESPYES DE ACT TODOS LOS REG
                    //blnNoExisteCte = false;
                        
				}//Fin si mapIdVinIdOpp.containsKey()

                //No esta en opportunidad
                if ( (!mapIdVinIdOpp.containsKey(sVin) && mapVinObjVeh.containsKey(sVin)) || blnNoExisteCte || Test.isRunningTest() ){
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdVinIdOpp y SI ESTA EN mapVinObjVeh sVin: ' + sVin);
                    //Obten el objeto del tipo Vehiculo__c objVehi
                    Vehiculo__c objVehiPaso = mapVinObjVeh.get(sVin);
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdVinIdOpp y SI ESTA EN mapVinObjVeh objVehiPaso: ' + objVehiPaso);

                    //Crea el id Externo apartir de los datos del cliente en Vehiculos
                    if (objVehiPaso.Ultimo_Movimiento__c != null){
	                    //Crea el objeto del tipo TAM_VentasCRM__c y metelo al mapa de mapVinObjVentasCRM
                        TAM_VentasCRM__c objVentaCrm = new TAM_VentasCRM__c(Name = sVin, 
                                FirstName__c = objVehiPaso.Ultimo_Movimiento__r.First_Name__c,
                                LastName__c = objVehiPaso.Ultimo_Movimiento__r.Last_Name__c,
                                Address2__c = objVehiPaso.Ultimo_Movimiento__r.Address_2__c,
                                City__c = objVehiPaso.Ultimo_Movimiento__r.City__c,
                                State__c = objVehiPaso.Ultimo_Movimiento__r.State__c,
                                Zip__c = objVehiPaso.Ultimo_Movimiento__r.Zip__c,
                                TelHome__c = objVehiPaso.Ultimo_Movimiento__r.Tel_Home__c,
                                TelWork__c = objVehiPaso.Ultimo_Movimiento__r.Tel_Work__c,
                                Email__c = objVehiPaso.Ultimo_Movimiento__r.E_Mail_2__c,
                                TAM_TipoCliente__c = 'Primero',
                                IdDealerCode__c = objVehiPaso.CodigoDistribuidor__c
                        );	                    
                        //Metelo al mapa de mapVinObjVentasCRM     
	                    mapVinObjVentasCRM.put(sVin,objVentaCrm);
                        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdVinIdOpp y SI ESTA EN mapVinObjVeh sVin: ' + sVin + ' objVentaCrm: ' + objVentaCrm);
                        //Crea el objeto del tipo TAM_VehiculoPaso__c y metelo al mapa de mapVinObjVehiculoPaso
                        TAM_VehiculoPaso__c objVehPaso = new TAM_VehiculoPaso__c(
                                Name = sVin, 
                                TAM_IdDealerCode__c = objVehiPaso.CodigoDistribuidor__c,
                                TAM_lsAssesor__c = null,
                                TAM_SaleCode__c = objVehiPaso.Ultimo_Movimiento__r.Sale_Code__c,
                                TAM_SaleDate__c = String.valueOf(objVehiPaso.Ultimo_Movimiento__r.Sale_Date__c),
                                TAM_SubmittedDate__c = String.valueOf(objVehiPaso.Ultimo_Movimiento__r.Submitted_Date__c),
                                TAM_SubmittedTime__c = objVehiPaso.Ultimo_Movimiento__r.Submitted_Time__c,
                                TAM_TransType__c = objVehiPaso.Ultimo_Movimiento__r.Trans_Type__c,
                                TAM_IdModelo__c = objVehiPaso.Ultimo_Movimiento__r.TAM_codigoModelo__c,
                                TAM_YearModelo__c = objVehiPaso.Ultimo_Movimiento__r.Year_Modelo__c,
                                TAM_IdColorInt__c = objVehiPaso.ColorInternoVehiculo__c != null ? objVehiPaso.ColorInternoVehiculo__r.CodigoColor__c : null,
                                TAM_DescrColorInt__c = objVehiPaso.ColorInternoVehiculo__c != null ? objVehiPaso.ColorInternoVehiculo__r.Name :  null,
                                TAM_IdColorExt__c = objVehiPaso.ColorExternoVehiculo__c != null ? objVehiPaso.ColorExternoVehiculo__r.CodigoColor__c : null,
                                TAM_DescrColorExt__c = objVehiPaso.ColorExternoVehiculo__c != null ? objVehiPaso.ColorExternoVehiculo__r.Name :  null,
                                TAM_Serial__c = objVehiPaso.SerieAD__c,
                                TAM_Year__c = objVehiPaso.Ultimo_Movimiento__r.Year__c,
                                TAM_Month__c = objVehiPaso.Ultimo_Movimiento__r.Month__c
                        );
                        //Metelo al mapa de mapVinObjVehiculoPaso                                                
                        mapVinObjVehiculoPaso.put(sVin, objVehPaso);
                        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdVinIdOpp y SI ESTA EN mapVinObjVeh sVin: ' + sVin + ' objVehPaso: ' + objVehPaso);                        
                    }//Fin si objVehiPaso.Ultimo_Movimiento__c != null
                
                    //Ya tienes la info para crear los clientes 
		            List<TAM_VentasCRM__c> lVentasUps = mapVinObjVentasCRM.values();
		            //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
		            List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lVentasUps, TAM_VentasCRM__c.id, false);
		            //Ve si hubo error
		            for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
		                if (!objDtbUpsRes.isSuccess())
		                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Hubo un error a la hora de crear/Actualizar los registros en TAM_VentasCRM__c ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
		                if (objDtbUpsRes.isSuccess())
		                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Los datos del Cte Vehic se crear/Actualizar con exito TAM_VentasCRM__c objDtbUpsRes.getId(): ' + objDtbUpsRes.getId());
		            }//Fin del for para lDtbUpsRes
                
                    //Ya tienes la info para crear los clientes 
                    List<TAM_VehiculoPaso__c> lVehicUps = mapVinObjVehiculoPaso.values();
                    //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
                    List<Database.Upsertresult> lDtbUpsRes2 = Database.upsert(lVehicUps, TAM_VehiculoPaso__c.id, false);
                    //Ve si hubo error
                    for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes2){
                        if (!objDtbUpsRes.isSuccess())
                            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Hubo un error a la hora de crear/Actualizar los registros en TAM_VehiculoPaso__c ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        if (objDtbUpsRes.isSuccess())
                            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Los datos del Cte Vehic se crear/Actualizar con exito TAM_VehiculoPaso__c objDtbUpsRes.getId(): ' + objDtbUpsRes.getId());
                    }//Fin del for para lDtbUpsRes
                    
                    Integer intCntTotOpp = 0;
                    Opportunity oppDel;
                    //Consulta la opp rel a la vin de sVin                
			        for (Opportunity opp : [Select o.TAM_Vin__c, o.Id, o.AccountId,o.Account.Name, Account.TAM_IdExternoNombre__c,
			            o.TAM_Distribuidor__r.Name, o.TAM_Distribuidor__c, OwnerId, TAM_IdExterno__c 
			            From Opportunity o Where TAM_Vin__c =: sVin ]){
                        //Crea el objeto del tipo 
	                    String sIdOwner = opp.OwnerId;                  
	                    String sIdCte = opp.AccountId;
	                    String sIdVehi = Test.isRunningTest() ? null : mapVinObjVeh.get(sVin).id;
	                    String sIsExtCteVehi = sIdCte + '-' + sIdVehi;                  
                        //Valida la longitud del nombre del cliente
                        String sNombreCtePaso = opp.Account.TAM_IdExternoNombre__c != null ? opp.Account.TAM_IdExternoNombre__c : opp.Account.Name;
                        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdVinIdOpp y SI ESTA EN mapVinObjVeh sNombreCtePaso: ' + sNombreCtePaso);
                        String sNombCte = sNombreCtePaso != null ? (sNombreCtePaso.length() > 59 ? sNombreCtePaso.substring(0,59) + ' - ' + sVin : sNombreCtePaso + ' - ' + sVin) : ''; 
	                    //String sNombCte = opp.Account.TAM_IdExternoNombre__c != null ? opp.Account.TAM_IdExternoNombre__c.substring(0,59) + ' - ' + sVin : opp.Account.Name.substring(0,59) + ' - ' + sVin; 
	                    //Ya existe el clienrte entonces crea el objeto del TAM_ClienteVehiculo__c
                        TAM_ClienteVehiculo__c objCteVehic = new TAM_ClienteVehiculo__c(
                                Name = sNombCte,
                                TAM_IdExterno__c = sIsExtCteVehi, 
                                TAM_Cliente__c = sIdCte,
                                TAM_VehIculo__c = sIdVehi,
                                OwnerId = sIdOwner
                        );
                        //Metelo al mapa de mapIdExtObjCteVehUps
                        if (sIdCte != null)
	                       mapIdExtObjCteVehUps.put(sIsExtCteVehi, objCteVehic);
                        mapVinNomCte.put(opp.TAM_Vin__c, opp);

                        //Suma uno al contador
                        intCntTotOpp++;
                        if (sIdCte == null)
                            oppDel = new Opportunity(id = opp.id);                            
			        }
			        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtObjCteVehUps0: ' + mapIdExtObjCteVehUps.keyset());
			        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtObjCteVehUps0: ' + mapIdExtObjCteVehUps.values());
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros intCntTotOpp: ' + intCntTotOpp + ' oppDel: ' + oppDel);
                    
                    //Esta duplicado el registro del vin en la opp
                    if (intCntTotOpp > 1)
                        if (oppDel.id != null)
                            if (!Test.isRunningTest())
                                delete oppDel;
                            
                    //Ve si ya existe una factura asociada a esta venta y crea el objeto del tipo TAM_OportunidadFactura__c
                    for (Factura__c objFactura : [Select f.TAM_VinForm__c, f.TAM_Numero__c, f.Name, f.Id 
                        From Factura__c f Where TAM_VinForm__c = :sVin]){
                        //Crea el objeto del tipo TAM_OportunidadFactura__c
                        TAM_OportunidadFactura__c objTAMOportunidadFacturaPaso = new TAM_OportunidadFactura__c();
                        objTAMOportunidadFacturaPaso.Name = sVin + ' - ' + objFactura.TAM_Numero__c;
                        objTAMOportunidadFacturaPaso.TAM_Factura__c =  objFactura.id;
                        objTAMOportunidadFacturaPaso.TAM_Oportunidad__c = mapVinNomCte.get(sVin).id;
                        String sIdExterno = mapVinNomCte.get(sVin).id + '-' +  objFactura.id;
                        //Metelo a la lista de mapVinObjOppFactIns
                        mapVinObjOppFactIns.put(sIdExterno, objTAMOportunidadFacturaPaso);
                    }
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjOppFactIns: ' + mapVinObjOppFactIns.keyset());
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapVinObjOppFactIns: ' + mapVinObjOppFactIns.values());
                    
                    //Ya tienes la info para crear los clientes 
                    List<TAM_OportunidadFactura__c> lOppFactUps = mapVinObjOppFactIns.values();
                    //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
                    List<Database.Upsertresult> lDtbUpsRes3 = Database.upsert(lOppFactUps, TAM_OportunidadFactura__c.id, false);
                    //Ve si hubo error
                    for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes3){
                        if (!objDtbUpsRes.isSuccess())
                            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Hubo un error a la hora de crear/Actualizar los registros en TAM_OportunidadFactura__c1 ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        if (objDtbUpsRes.isSuccess())
                            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Los datos del Cte Vehic se crear/Actualizar con exito TAM_OportunidadFactura__c1 objDtbUpsRes.getId(): ' + objDtbUpsRes.getId());
                    }//Fin del for para lDtbUpsRes
                    
                }//Fin si mapIdVinIdOpp.containsKey()
                
                //No tiene opp ni tiene Vehivulo asociado
                if (!mapIdVinIdOpp.containsKey(sVin) && !mapVinObjVeh.containsKey(sVin)){
                    System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros NO ESTA EN mapIdVinIdOpp sVin y NO ESTA EN mapVinObjVeh: ' + sVin);
                    setVinNoExist.add(sVin);
                }//Fin si mapIdVinIdOpp.containsKey()

            }//Fin si !mapIdExtIdCte.containsKey(sIdExtNom)
            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtObjCteVehUps1: ' + mapIdExtObjCteVehUps.keyset());
            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtObjCteVehUps1: ' + mapIdExtObjCteVehUps.values());
            System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros setVinNoExist1: ' + setVinNoExist);
		}//Fin del for para setVines
		
		Set<String> setIdCteVehic = new Set<String>(); 
		//Recorre la lista de mapIdExtObjCteVehUps.values() y deja solo el que tiene los datos de los campos
		//Select t.TAM_VehIculo__c, t.TAM_Cliente__c From TAM_ClienteVehiculo__c t
		for (TAM_ClienteVehiculo__c objCteVehiPaso :  mapIdExtObjCteVehUps.values()){
		    if (objCteVehiPaso.TAM_VehIculo__c != null && objCteVehiPaso.TAM_Cliente__c != null)
		      mapIdExtObjCteVehUpsFinal.put(objCteVehiPaso.Name, objCteVehiPaso);
            if (objCteVehiPaso.TAM_VehIculo__c == null || objCteVehiPaso.TAM_Cliente__c == null)
              setIdCteVehic.add(objCteVehiPaso.TAM_IdExterno__c);
		}
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtObjCteVehUpsFinal: ' + mapIdExtObjCteVehUpsFinal.keyset());
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros mapIdExtObjCteVehUpsFinal: ' + mapIdExtObjCteVehUpsFinal.values());
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros setIdCteVehic: ' + setIdCteVehic);
        
        Map<String, Lead> mapLeadUps = new Map<String, Lead>();
        Map<String, TAM_LeadInventarios__c> mapLeadInvUps = new Map<String, TAM_LeadInventarios__c>();
		
		//Ve si existe el VIN asociado a un lead y actualiza el estado a Entregado
        if (!Test.isRunningTest()){
	        for (TAM_LeadInventarios__c objLeadInvent : [Select t.id, t.TAM_Prospecto__c, T.Name From TAM_LeadInventarios__c t 
	            Where Name IN :mapVinObjVeh.keyset() And TAM_Prospecto__c != null]){
	            String sVinPaso = objLeadInvent.Name;
	            String sNombCompForm = mapVinObjVeh.get(sVinPaso).Ultimo_Movimiento__r.TAM_NombrecCompletoFrm__c.replaceAll('  ', ' ');
	            //Crea el objeto del lead    
	            Lead CandUpd = new Lead(
	                id = objLeadInvent.TAM_Prospecto__c, TAM_PedidoReportado__c = true, 
	                Status = 'Entregado', FWY_Estado_del_candidatoWEB__c = 'Entregado', 
	                TAM_PorcentajeAvance__c = '100%', 
	                TAM_FechaEntrega__c = mapVinObjVeh.get(sVinPaso).Ultimo_Movimiento__r.Submitted_Date__c 
	            );
	            //mete los datos en el mapa de mapIdInveCand para mandar llamar el proceso ActualizaVinCandito
	            mapLeadUps.put(objLeadInvent.TAM_Prospecto__c, CandUpd);
	            mapLeadInvUps.put(objLeadInvent.id, new TAM_LeadInventarios__c(id = objLeadInvent.id, TAM_NombreClienteHistorico__c = sNombCompForm));
	        }    
        }//Fin si!Test.isRunningTest()
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler mapLeadUps: '+ mapLeadUps);
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler mapLeadInvUps: '+ mapLeadInvUps);

        //Actualiza la info		
		if (!mapLeadUps.isEmpty() && !Test.isRunningTest())
		  upsert mapLeadUps.values() Lead.id;
        //Actualiza la info     
        if (!mapLeadInvUps.isEmpty() && !Test.isRunningTest())
          upsert mapLeadInvUps.values() TAM_LeadInventarios__c.id;
		
		TAM_ClienteVehiculo__c objCteVehi = new TAM_ClienteVehiculo__c();
		if (!setIdCteVehic.isEmpty() && !Test.isRunningTest()){
	        //Consulta los datos de los Ctes Vehic
	        for (TAM_ClienteVehiculo__c objCteVehic : [Select id  From TAM_ClienteVehiculo__c 
	            Where TAM_IdExterno__c IN :setIdCteVehic]){
	            //Inicializa el objeto de objCteVehi
	            objCteVehi = new TAM_ClienteVehiculo__c(id = objCteVehic.id);
	        }
	        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros objCteVehi: ' + objCteVehi);
			if (objCteVehi.id != null)
			    if (!Test.isRunningTest())  
			          delete objCteVehi;
		}//Fin si !setIdCteVehic.isEmpty()
		
        //Recorre la lista de CteServList y toma el vin que viene en el campo de Name
        for (TAM_ConsiltaDatosClienteVIN__c objVinPaso : CteServList){
            //Ve si el vin esta en el set de setVinNoExist y axctueliza el campo TAM_SinCliente__c
            if (setVinNoExist.contains(objVinPaso.Name))
                objVinPaso.TAM_SinCliente__c = true;
        }
        System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros setVines: ' + setVines);

        //Ve si tiene algo la lista de mapInvDummyPasoUpd
        if (!mapIdExtObjCteVehUpsFinal.isEmpty()){
			List<TAM_ClienteVehiculo__c> lCtesVehicUps = mapIdExtObjCteVehUpsFinal.values();
            //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
			List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lCtesVehicUps, TAM_ClienteVehiculo__c.TAM_IdExterno__c, false);
			//Ve si hubo error
			for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
				if (!objDtbUpsRes.isSuccess())
					System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Hubo un error a la hora de crear/Actualizar los registros en Cte Vehic ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
				if (objDtbUpsRes.isSuccess()){
					System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler Los datos del Cte Vehic se crear/Actualizar con exito objDtbUpsRes.getId(): ' + objDtbUpsRes.getId());
					setIdCteVehicNvo.add(objDtbUpsRes.getId());
				}
			}//Fin del for para lDtbUpsRes
        }//Fin si !mapInvDummyPasoUpd.isEmpty()
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros setIdCteVehicNvo: ' + setIdCteVehicNvo);

		//Consulta los datos de los Ctes Vehic
		if (setIdCteVehicNvo.isEmpty() || !Test.isRunningTest()){
			for (TAM_ClienteVehiculo__c objCteVehic : [Select id, TAM_VehIculo__r.Name, OwnerId, 
			    TAM_VehIculo__r.CodigoDistribuidor__c From TAM_ClienteVehiculo__c 
			    Where id IN :setIdCteVehicNvo]){
				String IdNomdis = mapNoDistObj.containsKey(objCteVehic.TAM_VehIculo__r.CodigoDistribuidor__c) ? mapNoDistObj.get(objCteVehic.TAM_VehIculo__r.CodigoDistribuidor__c) : '';
				System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros IdNomdis: ' + IdNomdis);
				if (Test.isRunningTest())
					IdNomdis = 'TMEX';	
				lClienteVehiculoShare.add(new TAM_ClienteVehiculo__Share(
						ParentId = objCteVehic.id,
						UserOrGroupId = mapIdGrupoNombre.get(IdNomdis),
						AccessLevel = 'Read'
					)
				);			
			}
		}//Fin si setIdCteVehicNvo.isEmpty()
		System.debug('EN TAM_ConsiltaDatosClienteVIN_tgr_handler.actalizaRegistros lClienteVehiculoShare: ' + lClienteVehiculoShare);
		
   		//Actualiza las Opp 
		List<Database.Saveresult> lDtbUpsRes = Database.insert(lClienteVehiculoShare, false);
		//Ve si hubo error
		for (Database.Saveresult objDtbUpsRes : lDtbUpsRes){
			if (!objDtbUpsRes.isSuccess())
       			System.debug('En la AccSh: hubo error a la hora de crear/Actualizar el precio de lista de la CteVehic: ' + objDtbUpsRes.getErrors()[0].getMessage());
		}//Fin del for para lDtbUpsRes
						
	}

}